-- automatically generated by BNF Converter
module Main where


import IO ( stdin, hGetContents )
import System ( getArgs, getProgName )

import Lexsyntax
import Parsyntax
import Skelsyntax
import Printsyntax
import Abssyntax

import Control.Monad.State hiding (State)
import Data.Map as Map hiding (showTree)
import Typecheck

import ErrM

type ParseFun a = [Token] -> Err a

myLLexer = myLexer

type Verbosity = Int


splitFunStm :: [FuncStm] -> ([Func],[Stm])
splitFunStm [] = ([],[])
splitFunStm ((F f):fss) = let (fs,ss) = splitFunStm fss in (f:fs,ss)
splitFunStm ((S s):fss) = let (fs,ss) = splitFunStm fss in (fs,s:ss)

putStrV :: Verbosity -> String -> IO ()
putStrV v s = if v > 1 then putStrLn s else return ()

runFile :: Verbosity -> ParseFun Program -> FilePath -> IO ()
runFile v p f = putStrLn f >> readFile f >>= run v p

run :: Verbosity -> ParseFun Program -> String -> IO ()
run v p s = let ts = myLLexer s in case p ts of
	Bad s    -> do
		putStrLn "\nParse              Failed...\n"
		putStrV v "Tokens:"
		putStrV v $ show ts
		putStrLn s
	Ok (Program s) -> let (fun,st) = splitFunStm (s) in do
		putStrLn "\nParse Successful!"
		showTree v (Program s)
		runStateT (mapM typeCheckStm st) State{variables=[empty], functions=[empty], function=(Ident "")}
		print "The program is type-correct!!"
		return ()

showTree :: (Show a, Print a) => Int -> a -> IO ()
showTree v tree
 = do
      putStrV v $ "\n[Abstract Syntax]\n\n" ++ show tree
      putStrV v $ "\n[Linearized tree]\n\n" ++ printTree tree

main :: IO ()
main = do args <- getArgs
          case args of
            [] -> hGetContents stdin >>= run 2 pProgram
            "-s":fs -> mapM_ (runFile 0 pProgram) fs
            fs -> mapM_ (runFile 2 pProgram) fs





